Package com.io7m.smfj.serializer.api

## Interface SMFSerializerDataAttributesValuesType

- All Superinterfaces:
    `java.lang.AutoCloseable`, `java.io.Closeable`
  All Known Implementing Classes:
    `WriterBase`, `WriterBEFloat1_16`, `WriterBEFloat1_32`, `WriterBEFloat1_64`, `WriterBEFloat2_16`, `WriterBEFloat2_32`, `WriterBEFloat2_64`, `WriterBEFloat3_16`, `WriterBEFloat3_32`, `WriterBEFloat3_64`, `WriterBEFloat4_16`, `WriterBEFloat4_32`, `WriterBEFloat4_64`, `WriterBESigned1_16`, `WriterBESigned1_32`, `WriterBESigned1_64`, `WriterBESigned2_16`, `WriterBESigned2_32`, `WriterBESigned2_64`, `WriterBESigned3_16`, `WriterBESigned3_32`, `WriterBESigned3_64`, `WriterBESigned4_16`, `WriterBESigned4_32`, `WriterBESigned4_64`, `WriterBEUnsigned1_16`, `WriterBEUnsigned1_32`, `WriterBEUnsigned1_64`, `WriterBEUnsigned2_16`, `WriterBEUnsigned2_32`, `WriterBEUnsigned2_64`, `WriterBEUnsigned3_16`, `WriterBEUnsigned3_32`, `WriterBEUnsigned3_64`, `WriterBEUnsigned4_16`, `WriterBEUnsigned4_32`, `WriterBEUnsigned4_64`, `WriterLEFloat1_16`, `WriterLEFloat1_32`, `WriterLEFloat1_64`, `WriterLEFloat2_16`, `WriterLEFloat2_32`, `WriterLEFloat2_64`, `WriterLEFloat3_16`, `WriterLEFloat3_32`, `WriterLEFloat3_64`, `WriterLEFloat4_16`, `WriterLEFloat4_32`, `WriterLEFloat4_64`, `WriterLESigned1_16`, `WriterLESigned1_32`, `WriterLESigned1_64`, `WriterLESigned2_16`, `WriterLESigned2_32`, `WriterLESigned2_64`, `WriterLESigned3_16`, `WriterLESigned3_32`, `WriterLESigned3_64`, `WriterLESigned4_16`, `WriterLESigned4_32`, `WriterLESigned4_64`, `WriterLEUnsigned1_16`, `WriterLEUnsigned1_32`, `WriterLEUnsigned1_64`, `WriterLEUnsigned2_16`, `WriterLEUnsigned2_32`, `WriterLEUnsigned2_64`, `WriterLEUnsigned3_16`, `WriterLEUnsigned3_32`, `WriterLEUnsigned3_64`, `WriterLEUnsigned4_16`, `WriterLEUnsigned4_32`, `WriterLEUnsigned4_64`

      public interface SMFSerializerDataAttributesValuesType
      extends java.io.Closeable

  Functions for serializing values.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `serializeValueFloat1​(double x)` | Serialize a value.
    `void` | `serializeValueFloat2​(double x, double y)` | Serialize a value.
    `void` | `serializeValueFloat3​(double x, double y, double z)` | Serialize a value.
    `void` | `serializeValueFloat4​(double x, double y, double z, double w)` | Serialize a value.
    `void` | `serializeValueIntegerSigned1​(long x)` | Serialize a value.
    `void` | `serializeValueIntegerSigned2​(long x, long y)` | Serialize a value.
    `void` | `serializeValueIntegerSigned3​(long x, long y, long z)` | Serialize a value.
    `void` | `serializeValueIntegerSigned4​(long x, long y, long z, long w)` | Serialize a value.
    `void` | `serializeValueIntegerUnsigned1​(long x)` | Serialize a value.
    `void` | `serializeValueIntegerUnsigned2​(long x, long y)` | Serialize a value.
    `void` | `serializeValueIntegerUnsigned3​(long x, long y, long z)` | Serialize a value.
    `void` | `serializeValueIntegerUnsigned4​(long x, long y, long z, long w)` | Serialize a value.

    - ### Methods inherited from interface java.io.Closeable

      `close`

- - ### Method Detail

    - #### serializeValueFloat4

          void serializeValueFloat4​(double x,
                                    double y,
                                    double z,
                                    double w)
                             throws java.io.IOException,
                                    java.lang.IllegalArgumentException,
                                    java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
        `z` - The z value
        `w` - The w value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueFloat3

          void serializeValueFloat3​(double x,
                                    double y,
                                    double z)
                             throws java.io.IOException,
                                    java.lang.IllegalArgumentException,
                                    java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
        `z` - The z value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueFloat2

          void serializeValueFloat2​(double x,
                                    double y)
                             throws java.io.IOException,
                                    java.lang.IllegalArgumentException,
                                    java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueFloat1

          void serializeValueFloat1​(double x)
                             throws java.io.IOException,
                                    java.lang.IllegalArgumentException,
                                    java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerSigned4

          void serializeValueIntegerSigned4​(long x,
                                            long y,
                                            long z,
                                            long w)
                                     throws java.io.IOException,
                                            java.lang.IllegalArgumentException,
                                            java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
        `z` - The z value
        `w` - The w value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerSigned3

          void serializeValueIntegerSigned3​(long x,
                                            long y,
                                            long z)
                                     throws java.io.IOException,
                                            java.lang.IllegalArgumentException,
                                            java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
        `z` - The z value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerSigned2

          void serializeValueIntegerSigned2​(long x,
                                            long y)
                                     throws java.io.IOException,
                                            java.lang.IllegalArgumentException,
                                            java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerSigned1

          void serializeValueIntegerSigned1​(long x)
                                     throws java.io.IOException,
                                            java.lang.IllegalArgumentException,
                                            java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerUnsigned4

          void serializeValueIntegerUnsigned4​(long x,
                                              long y,
                                              long z,
                                              long w)
                                       throws java.io.IOException,
                                              java.lang.IllegalArgumentException,
                                              java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
        `z` - The z value
        `w` - The w value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerUnsigned3

          void serializeValueIntegerUnsigned3​(long x,
                                              long y,
                                              long z)
                                       throws java.io.IOException,
                                              java.lang.IllegalArgumentException,
                                              java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
        `z` - The z value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerUnsigned2

          void serializeValueIntegerUnsigned2​(long x,
                                              long y)
                                       throws java.io.IOException,
                                              java.lang.IllegalArgumentException,
                                              java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
        `y` - The y value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors

    - #### serializeValueIntegerUnsigned1

          void serializeValueIntegerUnsigned1​(long x)
                                       throws java.io.IOException,
                                              java.lang.IllegalArgumentException,
                                              java.lang.IllegalStateException

      Serialize a value.
      Parameters:
        `x` - The x value
      Throws:
        `java.lang.IllegalStateException` - If the header has not yet been serialized
        `java.lang.IllegalStateException` - If the serializer has previously failed
        `java.lang.IllegalArgumentException` - If the current attribute is not of a type appropriate to this method call
        `java.io.IOException` - On I/O errors